#ifndef __IUF_AST
#define __IUF_AST
/** This class represent a generic asteroid.
Version History {\small 
\begin{itemize}
\item 0.1 First Release.
\item 0.4s Added methods for explosions (\Ref{Explode},\Ref{Hit}) and the strenght of the asteroids.
In this way how and if an asteroid explode is a characteristic of the asteroids itself.
\end{itemize}
}
*/
#include "Triangle.h"

class Ast : public GameObj
{
public:
	 /** Default Sizes of Asteroids
	 @name LargeSize=12, MediumSize=6, SmallSize=3
	 The asteroids has only three valid sizes. When an asteroid explode 
	 it splits into two (or more) smaller asteroids
	 */
	 enum {LargeSize=20, MediumSize=10, SmallSize=5};
	
	/** The radius (mt) of the Asteroid */
	float size;

	/** How resistent is an asteroid.
	*/
	int strenght;

	/** default constructor sets also the radius
	*/
	Ast(){
		size=1;
		}
/** Specialized constructor to set also angular velocity and size
	*/
Ast(const Point3f &_p, const float _angle, const Point3f &_v, float _av,float _size):
			GameObj(_p,_angle,_v){
				av=_av;
				size=_size;
			}

/** 
Draw the asteroid shape.
In this base class it is just a square with the give size.
*/

	virtual int Draw();

	/** Make the asteroid explode.
	In this base class do nothing. (i'm lazy); see the \Ref{Ast3DFract} explode 
	to find something of more interesting.
	*/
	
	virtual void Explode(list<Ast *> &AL, list<GameObj *> &OL){};
	
	virtual void Hit(Bullet *b, list<Ast *> &AL, list<GameObj *> &OL);

	/** Generate in a preprocessing step all the sub asteroids.
	see the \Ref{Ast3DFract} GenerateSub()
	to find something of more interesting.
	*/
	
	virtual void GenerateSub(Mesh &AstM){};

	/** The vector of the Sub-asteroids.
	These Sub-asteroid are generate by the GenerateSub() func and used when the the asteroid itself explode.
	*/
  vector<Ast *> Sub; 

	/** Points gained.
	Each asteroid can freely decide how many points you earn.
	*/
	virtual int Points(){return 10;};
};
#endif